package de.unibi.airobots.bonsai.util.arm.calibration;

import java.io.FileOutputStream;
import java.io.IOException;
import java.util.ArrayList;

import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;
import javax.xml.xpath.XPath;
import javax.xml.xpath.XPathConstants;
import javax.xml.xpath.XPathExpression;
import javax.xml.xpath.XPathFactory;

import org.w3c.dom.Document;
import org.w3c.dom.NodeList;

import de.unibi.airobots.bonsai.actuators.PoseActuatorTobi;
import de.unibi.airobots.bonsai.core.Sensor;
import de.unibi.airobots.bonsai.core.SensorListener;
import de.unibi.airobots.bonsai.util.arm.ArmController180;
import de.unibi.airobots.btl.data.geometry.Point3D;
import de.unibi.airobots.btl.data.grasp.KatanaPoseData;
import de.unibi.airobots.btl.units.AngleUnit;
import de.unibi.airobots.btl.units.LengthUnit;

public class Writing {//implements SensorListener<Point3D> {
	public Sensor<Point3D> chessboardSensor;
	public PoseActuatorTobi poseActuatorTobi;
	private ArmController180 ac;
	
	public void dd() {
		this.ac.adjustCurrentPosition(0, 10, 0);
		System.exit(0);
	}
	
	public Writing(Sensor<Point3D> cS, ArmController180 armController) {
		
		chessboardSensor = cS;
		//chessboardSensor.addSensorListener(this);
	
		ac = armController;
		recordMovement();
		write(); //drives to all positions form write.xml
	}
	
	private void recordMovement() {

		String out = "<record>\n";
		int key = 0;
		while(true) {
			KatanaPoseData kpd = this.ac.getPosition();
			try {
				key = System.in.read();
			} catch (IOException e1) {
				// TODO Auto-generated catch block
				e1.printStackTrace();
			}
			System.out.println("jau");
			out += "\t<p x=\"" + kpd.getX(LengthUnit.MILLIMETER) + "\" y=\"" + kpd.getY(LengthUnit.MILLIMETER) + "\" z=\"" + kpd.getZ(LengthUnit.MILLIMETER) + "\"" +
					" phi=\"" + kpd.getPhi(AngleUnit.RADIAN) + "\" psi=\"" + kpd.getPsi(AngleUnit.RADIAN) + "\" theta=\"" + kpd.getTheta(AngleUnit.RADIAN) + "\" />\n";
			String out2 = out + "</record>";
			FileOutputStream fs;
			try {
				fs = new FileOutputStream("/vol/robocup/trunk/etc/armcalibration/writing.xml");
				fs.write(out2.getBytes());
				fs.close();
			} catch (Exception e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
		}
	}
	
	private ArrayList<KatanaPoseData> readXMLFile(String filename) {
		ArrayList<KatanaPoseData> poseList = new ArrayList<KatanaPoseData>();
		try {
			DocumentBuilderFactory domFactory = DocumentBuilderFactory.newInstance();
		    domFactory.setNamespaceAware(true);
		    DocumentBuilder builder = domFactory.newDocumentBuilder();
		    Document doc = builder.parse(filename);
	
			
			XPathFactory factory = XPathFactory.newInstance();
		    XPath xpath = factory.newXPath();
		    XPathExpression expr 
		     = xpath.compile("/record/p");
	
		    Object result = expr.evaluate(doc, XPathConstants.NODESET);
		    NodeList nodes = (NodeList) result;
		    for (int i = 0; i < nodes.getLength(); i++) {
		    	double phi = Double.parseDouble(nodes
		    			.item(i)
		    			.getAttributes()
		    			.item(0)
		    			.getNodeValue());
		    	double psi = Double.parseDouble(nodes.item(i).getAttributes().item(1).getNodeValue());
		    	double theta = Double.parseDouble(nodes.item(i).getAttributes().item(2).getNodeValue());
		    	double x = Double.parseDouble(nodes.item(i).getAttributes().item(3).getNodeValue());
		    	double y = Double.parseDouble(nodes.item(i).getAttributes().item(4).getNodeValue());
		    	double z = Double.parseDouble(nodes.item(i).getAttributes().item(5).getNodeValue());
		    	KatanaPoseData kpd = new KatanaPoseData(x, y, z, phi, psi, theta, AngleUnit.RADIAN, LengthUnit.MILLIMETER);
		    	poseList.add(kpd);
		    }
		} catch (Exception e) {
			e.printStackTrace();
		}
		return poseList;
	}
	
	public void write() {
		ArrayList<KatanaPoseData> kpdlist = this.readXMLFile("/vol/robocup/trunk/etc/armcalibration/write.xml");
		for(KatanaPoseData kpd: kpdlist) {
			this.ac.goTo(kpd);
			this.ac.waitAfterMovement(1);
		}
	}

//	public static void main(String[] args) {
//		BasicConfigurator.configure();
//		
//		// parse command line options
//		options = new TestOptions();
//		CmdLineParser parser = new CmdLineParser(options);
//		try {
//			parser.parseArgument(args);
//		} catch (CmdLineException e) {
//			System.err.println(e.getMessage());
//			System.err.println();
//			System.err.println("java CalibrationTest [options...]");
//			parser.printUsage(System.err);
//			System.exit(1);
//		}
//
//		// show help?
//		if (options.help) {
//			System.out.println("java CalibrationTest [options...]");
//			parser.printUsage(System.out);
//			System.exit(0);
//		}
//		
//		// start program
//		try {
//			Logger.getRootLogger().info("CalibrationTest started");
//			@SuppressWarnings("unused")
//			Writing control = new Writing(options.bonsaiConfig);
//
//		} catch (Exception e) {
//			Logger.getRootLogger().error(
//					"CalibrationTest threw an exception. \n\nError: ", e);
//		}
//	}

//	@Override
//	public void newDataAvailable(Point3D newData) {
//		// TODO Auto-generated method stub
//		
//	}
}
